%define ocamlname dune

Name:           ocaml-%{ocamlname}
Version:        1.1.1
Release:        2%{?dist}
Summary:        A composable build system for OCaml

License:        MIT
URL:            https://github.com/ocaml/dune
Source:		https://github.com/ocaml/dune/releases/download/1.1.1/dune-1.1.1.tbz

# dune calls  opam-installer
#Requires:	opam-installer
#BuildRequires:	opam-installer

BuildRequires:  ocaml >= 4.02.3

Provides:	jbuilder = %{version}
Obsoletes:      jbuilder < %{version}

%description
Fast, portable and opinionated build system

dune is a build system that was designed to simplify the release of
Jane Street packages. It reads metadata from "dune" files following a
very simple s-expression syntax.

dune is fast, it has very low-overhead and support parallel builds on
all platforms. It has no system dependencies, all you need to build
dune and packages using dune is OCaml. You don't need or make or bash
as long as the packages themselves don't use bash explicitly.

dune supports multi-package development by simply dropping multiple
repositories into the same directory.

It also supports multi-context builds, such as building against
several opam roots/switches simultaneously. This helps maintaining
packages across several versions of OCaml and gives cross-compilation
for free.

%prep
%setup -q -n %{ocamlname}-%{version}

%build
ocaml configure.ml --libdir %{_libdir}/ocaml
ocaml bootstrap.ml
./boot.exe --release $(echo '%{?_smp_mflags}' | sed 's#-j#-j #')

%install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_libdir}/ocaml/dune/
mkdir -p %{buildroot}%{_mandir}/man1

# The files to install are stored in _build as symlinks; dereference them.
cp -aL _build/install/default/bin/dune %{buildroot}%{_bindir}/
cp -aL _build/install/default/lib/dune/* %{buildroot}%{_libdir}/ocaml/dune/
cp -aL _build/install/default/man/man1/* %{buildroot}%{_mandir}/man1

ln -s dune %{buildroot}%{_bindir}/jbuilder

%files
%license LICENSE.md
#%doc %{_pkgdocdir}/README.md
#%doc %{_pkgdocdir}/CHANGES.md
%{_libdir}/ocaml/%{ocamlname}
%{_bindir}/%{ocamlname}
%{_bindir}/jbuilder
%{_mandir}/man1/dune.1*
%{_mandir}/man1/dune-build.1*
%{_mandir}/man1/dune-clean.1*
%{_mandir}/man1/dune-exec.1*
%{_mandir}/man1/dune-external-lib-deps.1*
%{_mandir}/man1/dune-install.1*
%{_mandir}/man1/dune-installed-libraries.1*
%{_mandir}/man1/dune-promote.1*
%{_mandir}/man1/dune-rules.1*
%{_mandir}/man1/dune-runtest.1*
%{_mandir}/man1/dune-subst.1*
%{_mandir}/man1/dune-uninstall.1*
%{_mandir}/man1/dune-utop.1*
%{_mandir}/man1/dune-help.1*
%{_mandir}/man1/dune-printenv.1*
